//
//  NSString+AdvancedSubstring.m
//  Daxhotel
//
//  Created by Raphael Schweikert on 29.07.05.
//  Copyright 2005 F uco. All rights reserved.
//

#import "NSString+AdvancedSubstring.h"


@implementation NSString (AdvancedSubstring)
- (NSString *) firstStringBetweenStart:(NSString *)searchPrefix andEnd:(NSString *)searchSuffix
{
    NSRange searchPrefixRange = [self rangeOfString:searchPrefix];
    if(searchPrefixRange.location==NSNotFound)
        return nil;
    int startOfIdentifier = searchPrefixRange.location+searchPrefixRange.length;
    NSRange searchSuffixRange = [self rangeOfString:searchSuffix options:0 range:NSMakeRange(startOfIdentifier,[self length]-startOfIdentifier)];
    if(searchSuffixRange.location==NSNotFound)
        return nil;
    int endOfIdentifier = searchSuffixRange.location;
    NSString *result = [self substringWithRange:NSMakeRange(startOfIdentifier, endOfIdentifier-startOfIdentifier)];
    return result;
}

- (NSArray *) allStringsBetweenStart:(NSString *)searchPrefix andEnd:(NSString *)searchSuffix
{
    NSMutableArray *theResult = [[NSMutableArray alloc] init];
    
    int doneIndex = 0;
    
    while(doneIndex < [self length])
    {
        NSRange searchPrefixRange = [self rangeOfString:searchPrefix options:0 range:NSMakeRange(doneIndex, [self length]-doneIndex)];
        if(searchPrefixRange.location==NSNotFound) break;
        int startOfIdentifier = searchPrefixRange.location+searchPrefixRange.length;
        NSRange searchSuffixRange = [self rangeOfString:searchSuffix options:0 range:NSMakeRange(startOfIdentifier, [self length]-startOfIdentifier)];
        if(searchSuffixRange.location==NSNotFound) break;
        int endOfIdentifier = searchSuffixRange.location;
        NSString *identifier = [self substringWithRange:NSMakeRange(startOfIdentifier, endOfIdentifier-startOfIdentifier)];
        doneIndex=startOfIdentifier;
        [theResult addObject:identifier];
    }
    return [theResult autorelease];
}

- (NSString *)stringByRemovingSurroundingWhitespace
{
    static NSCharacterSet *nonWhitespace = nil;
    NSRange firstValidCharacter, lastValidCharacter;
    
    if (!nonWhitespace)
    {
        nonWhitespace = [[NSCharacterSet alphanumericCharacterSet] retain];
    }
    
    firstValidCharacter = [self rangeOfCharacterFromSet:nonWhitespace];
    if (firstValidCharacter.length == 0)
	return @"";
    lastValidCharacter = [self rangeOfCharacterFromSet:nonWhitespace options:NSBackwardsSearch];
    
    if (firstValidCharacter.location == 0 && lastValidCharacter.location == [self length] - 1)
	return [[self retain] autorelease];
    else
	return [self substringWithRange:NSUnionRange(firstValidCharacter, lastValidCharacter)];
}

@end
